 var $fnapplicationkeyTextbox=jQuery("#applicationkey-textbox");

 $fnapplicationkeyTextbox.change(function () {
     bindDeviceId();
 });

 var $fndeviceidSelect = jQuery("#deviceid-select");
 var $fndeviceidTextbox=jQuery("#deviceid-textbox");
 var $fndeviceidBlock=jQuery("#deviceid-block");

 bindDeviceId();

 $fndeviceidSelect.change(function () {
     $fndeviceidTextbox.val($fndeviceidSelect.val());
 });

 jQuery('#new-type-checkbox').change(function () {
     var checked = jQuery(this).attr('checked');

     if (checked) {
         jQuery('#new-post-roles').show();
         jQuery('#new-post-types').show();
     } else {
         jQuery('#new-post-roles').hide();
         jQuery('#new-post-roles > input').removeAttr('checked');

         jQuery('#new-post-types').hide();
         jQuery('#new-post-types > input').removeAttr('checked');
     }
 });

function make_base_auth(user, password) {
  var tok = user + ':' + password;
  var hash = btoa(tok);
  return "Basic " + hash;
}

function bindDeviceId() {
    var apiKey = $fnapplicationkeyTextbox.val();
    if (apiKey !== undefined) {
        jQuery.ajax({
            type: "GET",
            url: "http://api.pushbullet.com/api/devices",
            dataType: 'json',
            async: false,
            beforeSend: function (xhr) {
                xhr.setRequestHeader('Authorization', make_base_auth(apiKey, ''));
            },
            success: function (msg) {
                for (var i = 0; i < msg.devices.length; i++) {
                    var device = msg.devices[i];
                    var id = device.id;
                    var name = '';
                    if (device.extras.manufacturer != null) {
                        name += device.extras.manufacturer + ' ';
                    }
                    if (device.extras.model != null) {
                        name += device.extras.model + ' ';
                    }
                    if (device.extras.android_version != null) {
                        name += '(' + device.extras.android_version + ')';
                    }

                    $fndeviceidSelect.append('<option value="' + id + '">' + name + '</option>');
                }

                if (msg.devices.length > 0) {
                    if ($fndeviceidTextbox.val() != '') {
                        $fndeviceidSelect.val($fndeviceidTextbox.val());
                    } else {
                        $fndeviceidSelect.val(msg.devices[0].id);
                    }

                    $fndeviceidSelect.show();
                    $fndeviceidBlock.hide();
                }
            }
        })
        .fail(function (jqXHR, textStatus) {
            $fndeviceidSelect.empty();
            $fndeviceidSelect.hide();

            $fndeviceidBlock.show();
            $fndeviceidTextbox.val('');
            alert(jqXHR.responseJSON.error.message);
        });
    }
}